Subject: Re: bug#51550: 29.0.50; Customize Group INS buttons sometimes don't have a left box line

From: Eli Zaretskii <[email-masked]>
Date: Wed, 29 Dec 2021 15:37:12 +0200

> From: Po Lu <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Wed, 29 Dec 2021 21:23:54 +0800
> 
> >  (insert #("foo\n foo " 0 4 (face widget-field) 4 5 (invisible t) 5 8 (face custom-button)))
> 
> I found another potential problem: determining the start of a box run
> doesn't take the before-string of an overlay into account.
> 
> wid-edit.el displays the button face through an overlay spanning from
> the start to the end of the button, and I wanted to solve this problem
> by adding a before-string containing a single invisible space, but that
> doesn't seem to be affecting the non-display of the button's left box
> line.

Why did you want to use a before-string? why not simply a single
invisible character before the button?  It sounds like an unnecessary
complication to me, since before-strings and after-strings are
inherently tricky, even when they aren't invisible.

But if you want me to look into this, you know what to do: show me a
short Lisp recipe which I could investigate.